/* Processed by ecpg (4.0.1) */
/* These include files are added by the preprocessor */
#include <ecpgtype.h>
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */
#line 1 "test_get_involved.pgc"
#include <stdio.h>
#include "callProcsViaC.h"

extern FILE *fp;


// get logname, lastname, firstname, role
// of each person involved in a given case


/***********************************************************************
 *                                                                     *
 * i want the function to return a struct of 5 values defined in       *
 * << callProcsViaC.h >>.                                              *
 *                                                                     *
 ***********************************************************************/

ms_involvedincase_tuple get_involved_in_case(int mstsCID)
{
  /* exec sql begin declare section */
                 // DECLARE the (input) case ID variable
   
   
   
   
   
   
   
   
   
   
  
#line 21 "test_get_involved.pgc"
 int  mstsCaseID  = mstsCID ;
 
#line 22 "test_get_involved.pgc"
 char  lognm [ LOG_NAME_LEN ]   ;
 
#line 23 "test_get_involved.pgc"
 char  lastnm [ LAST_NAME_LEN ]   ;
 
#line 24 "test_get_involved.pgc"
 char  firstnm [ FIRST_NAME_LEN ]   ;
 
#line 25 "test_get_involved.pgc"
 char  rol [ ROLE_LEN ]   ;
 
#line 26 "test_get_involved.pgc"
 int  success   ;
 
#line 27 "test_get_involved.pgc"
 short  lognm_ind   ;
 
#line 28 "test_get_involved.pgc"
 short  lastnm_ind   ;
 
#line 29 "test_get_involved.pgc"
 short  firstnm_ind   ;
 
#line 30 "test_get_involved.pgc"
 short  rol_ind   ;
 
#line 31 "test_get_involved.pgc"
 short  success_ind   ;
/* exec sql end declare section */
#line 32 "test_get_involved.pgc"


  /* declare c_1  cursor  for select  ms_getInvolvedInCase (  ? , refcursor )      */
#line 34 "test_get_involved.pgc"


  ms_involvedincase_tuple retval_tuple; 

  connect_to_postgresql();

  /* Branch to the notfound label when the "No data found" condition occurs. */
  /* exec sql whenever not found  goto  notfound ; */

#line 41 "test_get_involved.pgc"


  /************************************************************************
   * 
   *  the next line raises -202 'Too few arguments' from ECPGdebug
   *  it also doesn't work if i use a host variable (char array) instead 
   *      of the constant
   *  
   ************************************************************************/

  { ECPGdo(__LINE__, 0, 1, NULL, "select  ms_getInvolvedInCase (  ? , 'c_1' )     ", 
	ECPGt_int,&(mstsCaseID),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 51 "test_get_involved.pgc"

if (sqlca.sqlcode == ECPG_NOT_FOUND) goto notfound;}
#line 51 "test_get_involved.pgc"


  do { 
    { ECPGdo(__LINE__, 0, 1, NULL, "fetch next from c_1", ECPGt_EOIT, 
	ECPGt_char,(lognm),(long)LOG_NAME_LEN,(long)1,(LOG_NAME_LEN)*sizeof(char), 
	ECPGt_short,&(lognm_ind),(long)1,(long)1,sizeof(short), 
	ECPGt_char,(lastnm),(long)LAST_NAME_LEN,(long)1,(LAST_NAME_LEN)*sizeof(char), 
	ECPGt_short,&(lastnm_ind),(long)1,(long)1,sizeof(short), 
	ECPGt_char,(firstnm),(long)FIRST_NAME_LEN,(long)1,(FIRST_NAME_LEN)*sizeof(char), 
	ECPGt_short,&(firstnm_ind),(long)1,(long)1,sizeof(short), 
	ECPGt_char,(rol),(long)ROLE_LEN,(long)1,(ROLE_LEN)*sizeof(char), 
	ECPGt_short,&(rol_ind),(long)1,(long)1,sizeof(short), ECPGt_EORT);
#line 55 "test_get_involved.pgc"

if (sqlca.sqlcode == ECPG_NOT_FOUND) goto notfound;}
#line 55 "test_get_involved.pgc"


    strcpy(retval_tuple.lognm, lognm);
    strcpy(retval_tuple.lastnm, lastnm);
    strcpy(retval_tuple.firstnm, firstnm);
    strcpy(retval_tuple.rol, rol);

    printf("%s  %s  %s  %s\n", retval_tuple.lognm, retval_tuple.lastnm, retval_tuple.firstnm,
                               retval_tuple.rol);
  } while (1);

  { ECPGdo(__LINE__, 0, 1, NULL, "close c_1", ECPGt_EOIT, ECPGt_EORT);}
#line 66 "test_get_involved.pgc"


  disconnect_from_postgresql();

  return retval_tuple;

notfound:
  disconnect_from_postgresql();

  strcpy(retval_tuple.lognm, "");
  strcpy(retval_tuple.lastnm, "");
  strcpy(retval_tuple.firstnm, "");
  strcpy(retval_tuple.rol, "");

  return retval_tuple;
}
