#ifndef CALL_PROCS_VIA_C_H
#define CALL_PROCS_VIA_C_H


/* file callProcsViaC.h
 * modified: 4/26/2007  1:30a
 */ 


#define     LOG_NAME_LEN       20
#define     CASE_NAME_LEN      40
#define     ROLE_LEN           20
#define     DOC_TYPE_LEN       20
#define     DOC_TITLE_LEN      40
#define     DATE_LEN           40
#define     DOC_BODY_LEN       30000
#define     LAST_NAME_LEN      30
#define     FIRST_NAME_LEN     30
#define     EMAIL_ADDR_LEN     100
#define     SIGN_PLACE_LEN     40
#define     CASE_STATUS_LEN    20
#define     PHONE_NUMBER_LEN   20
#define     CASE_TITLE_LEN     40
#define     TARGET_LEN         40


/* Define constants for VARCHAR lengths. */
#define     UNAME_LEN          20
#define     PWD_LEN            40


typedef struct
{
  int dID;
  int versn;
  char dtcreated[DATE_LEN];
  char titl[DOC_TITLE_LEN];
  char bod[DOC_BODY_LEN];
  int success;
} ms_docversion_tuple;


typedef struct
{
  char lastnm[LAST_NAME_LEN];
  char firstnm[FIRST_NAME_LEN];
  char midinit;
  char homephn[PHONE_NUMBER_LEN];
  char workphn[PHONE_NUMBER_LEN];
  char cellphn[PHONE_NUMBER_LEN];
  char eml[EMAIL_ADDR_LEN];
  int success;
} ms_account_tuple;


typedef struct
{
  char casTitl[CASE_TITLE_LEN];
  int success;
} ms_casetitle_tuple;


typedef struct
{
  char rol[ROLE_LEN];
  int success;
} ms_getrole_tuple;


typedef struct
{
  char lognm[LOG_NAME_LEN];
  char lastnm[LAST_NAME_LEN];
  char firstnm[FIRST_NAME_LEN];
  char rol[ROLE_LEN];
  int success;
} ms_involvedincase_tuple;


#endif

