-- file: createProcedures2Pg.sql
-- modified: 5/1/07  1:45a 



-- ------------------------------------------------------------------------------------------

-- output logname, last name, first name, role for an
-- account associated with a given caseID
CREATE OR REPLACE FUNCTION ms_getInvolvedInCase (cID INTEGER, REFCURSOR) RETURNS REFCURSOR AS $$

BEGIN
  OPEN $2 FOR 
    SELECT ACR.logname, A.lastName, A.firstName, ACR.role
    FROM ms_account A, ms_accountCaseRole ACR
    WHERE ACR.caseID = cID AND
          ACR.logname = A.logname;

  RETURN $2;

END;

$$ LANGUAGE plpgsql;

-- ---------------------------------------------------------------------------


